package ru.ulstu.is.sbapp.HardwareShop.controller;

import com.fasterxml.jackson.annotation.JsonProperty;
import ru.ulstu.is.sbapp.HardwareShop.models.Product;

import java.nio.charset.StandardCharsets;

public class ProductDTO {
    private Long id;

    private Integer price;

    private String photo;

    @JsonProperty("categoryId")
    private Long category_id;

    private String name;

    public ProductDTO() {}

    public ProductDTO(Product product) {
        this.id = product.getId();
        this.name = product.getName();
        this.price = product.getPrice();
        this.photo = new String(product.getPhoto(), StandardCharsets.UTF_8);
        this.category_id = product.getCategory().getId();
    }

    public Long getId() {
        return id;
    }

    public String getName() { return name; }

    public Integer getPrice() {
        return price;
    }

    public String getPhoto() {
        return photo;
    }

    public Long getCategory_id() {
        return category_id;
    }

    public void setPhoto(String photo) { this.photo = photo; }

    public void setName(String name) { this.name = name; }

    public void setPrice(Integer price) { this.price = price; }
}
