package ru.ulstu.is.sbapp.HardwareShop.models;

import ru.ulstu.is.sbapp.HardwareShop.controller.CategoryDTO;
import ru.ulstu.is.sbapp.HardwareShop.controller.ProductDTO;

import javax.persistence.*;
import java.util.List;
import java.util.Objects;

@Entity
public class Category {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column
    private String name;

    public Category() {

    }

    public Category(String name) {
        this.name = name;
    }

    public Category(CategoryDTO categoryDTO){
        this.name = categoryDTO.getName();
    }

    public Long getId() { return id;}

    public String getName() { return name; }

    public void setName(String name) { this.name = name; }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Category category = (Category) o;
        return Objects.equals(id, category.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }

    @Override
    public String toString() {
        return "Category{" +
                "id=" + id +
                ", name='" + name + '\'' +
                '}';
    }
}
