package ru.ulstu.is.sbapp.HardwareShop.models;

import ru.ulstu.is.sbapp.HardwareShop.controller.CategoryDTO;
import ru.ulstu.is.sbapp.HardwareShop.controller.ManufacturerDTO;

import javax.persistence.*;
import java.util.List;
import java.util.Objects;

@Entity
public class Manufacturer {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @ManyToMany(fetch = FetchType.EAGER,
            mappedBy = "manufacturerList")
    private List<Product> productList;

    @Column
    private String name;
    private String address;


    public Manufacturer() {

    }

    public Manufacturer(String name, String address) {
        this.name = name;
        this.address = address;
    }

    public Manufacturer(ManufacturerDTO manufacturerDTO){
        this.name = manufacturerDTO.getName();
        this.address = manufacturerDTO.getAddress();
    }

    public Long getId() { return id;}

    public String getName() { return name; }

    public String getAddress() { return address; }

    public List<Product> getProductList() { return productList; }
    public void setName(String name) { this.name = name; }

    public void setAddress(String address) { this.address = address; }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Manufacturer manufacturer = (Manufacturer) o;
        return Objects.equals(id, manufacturer.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }

    @Override
    public String toString() {
        return "Manufacturer{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", address='" + address + '\'' +
                '}';
    }
}
