package ru.ulstu.is.sbapp;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.FilteredClassLoader;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.web.multipart.MultipartFile;
import ru.ulstu.is.sbapp.HardwareShop.models.Category;
import ru.ulstu.is.sbapp.HardwareShop.services.CategoryService;
import ru.ulstu.is.sbapp.HardwareShop.models.Product;
import ru.ulstu.is.sbapp.HardwareShop.services.ProductService;

import javax.persistence.EntityNotFoundException;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Base64;
import java.util.List;

@SpringBootTest
public class JpaProductTests {
    private static final Logger log = LoggerFactory.getLogger(JpaProductTests.class);

    @Autowired
    private ProductService productService;

    @Autowired
    private CategoryService categoryService;

    private MultipartFile ConvertFile() throws IOException {
        File file = new File("C:\\Users\\aleyc\\IdeaProjects\\IP_Aleikin_PIbd-22\\src\\test\\java\\ru\\ulstu\\is\\sbapp\\cart.png");
        String name = "file";
        String originalFileName = file.getName();
        String contentType = "image/jpeg";
        byte[] content = new byte[(int) file.length()];
        FileInputStream inputStream = new FileInputStream(file);
        inputStream.read(content);
        MultipartFile multipartFile = new MockMultipartFile(name, originalFileName, contentType, content);
        return multipartFile;
    }

    @Test
    void testProductCreate() throws Exception {
        MultipartFile localFile = ConvertFile();
        String strImage;
        strImage = ("data:" + localFile.getContentType() + ";base64," + Base64.getEncoder().encodeToString(localFile.getBytes()));
        productService.deleteAllProducts();
        final Product product = productService.addProduct(15000, strImage.getBytes(), "1412");
        log.info(product.toString());
        Assertions.assertNotNull(product.getId());
        Assertions.assertNotNull(product.getPhoto());
    }

    /*@Test
    void testProductRead() {
        productService.deleteAllProducts();
        final Product product = productService.addProduct(15000);
        log.info(product.toString());
        final Product findProduct = productService.findProduct(product.getId());
        log.info(findProduct.toString());
        Assertions.assertEquals(product, findProduct);
    }

    @Test
    void testProductReadNotFound() {
        productService.deleteAllProducts();
        Assertions.assertThrows(EntityNotFoundException.class, () -> productService.findProduct(-1L));
    }

    @Test
    void testProductReadAll() {
        productService.deleteAllProducts();
        productService.addProduct(15000);
        productService.addProduct(20000);
        final List<Product> productList = productService.findAllProducts();
        log.info(productList.toString());
        Assertions.assertEquals(productList.size(), 2);
    }

    @Test
    void testProductReadAllEmpty() {
        productService.deleteAllProducts();
        final List<Product> productList = productService.findAllProducts();
        log.info(productList.toString());
        Assertions.assertEquals(productList.size(), 0);
    }

    @Test
    void testProductUpdate() {
        productService.deleteAllProducts();
        final Product product = productService.addProduct(15000);
        log.info(product.toString());
        productService.updateProduct(product.getId(), 20000);
        log.info(product.toString());
        Assertions.assertEquals(product.getPrice(), 20000);
    }

    @Test
    void testProductAddCategory() {
        productService.deleteAllProducts();
        final Product product = productService.addProduct(15000);
        final Category category = categoryService.addCategory("Электроника");
        product.addCategory(category);
        log.info(product.toString() + product.getCategory().getName());
        Assertions.assertEquals(product.getCategory().getName(), "Электроника");
        productService.deleteAllProducts();
        categoryService.deleteAllCategories();
    }*/
}
