package ru.ulstu.is.sbapp;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.NoSuchBeanDefinitionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import ru.ulstu.is.sbapp.calc.service.CalculatorService;

@SpringBootTest
class SbappApplicationTests {
	@Autowired
	CalculatorService calculatorService;

	@Test
	void IntSum() {
		final String res = calculatorService.getSum(3, 6, "int").toString();
		Assertions.assertEquals("9", res);
	}

	@Test
	void IntDiff() {
		final String res = calculatorService.getDiff(15, 3, "int").toString();
		Assertions.assertEquals("12", res);
	}

	@Test
	void IntMul() {
		final String res = calculatorService.getMul(12, 3, "int").toString();
		Assertions.assertEquals("36", res);
	}

	@Test
	void IntDiv() {
		final String res = calculatorService.getDiv(12, 3, "int").toString();
		Assertions.assertEquals("4", res);
	}

	@Test
	void StringSum() {
		final String res = calculatorService.getSum("abc", 6, "string").toString();
		Assertions.assertEquals("abc6", res);
	}

	@Test
	void StringDiff() {
		final String res = calculatorService.getDiff("abc", 2, "string").toString();
		Assertions.assertEquals("a", res);
	}

	@Test
	void StringMul() {
		final String res = calculatorService.getMul("abc", 3, "string").toString();
		Assertions.assertEquals("abcabcabc", res);
	}

	@Test
	void StringDiv() {
		final String res = calculatorService.getDiv("abc", 3, "string").toString();
		Assertions.assertEquals("a", res);
	}

	@Test
	void FloatArraySum() {
		final String res = calculatorService.getSum("3.2;5.6", 3, "floatArray").toString();
		Assertions.assertEquals("[6.2, 8.6]", res);
	}

	@Test
	void FloatArrayDiff() {
		final String res = calculatorService.getDiff("3.2;5.6", 2, "floatArray").toString();
		Assertions.assertEquals("[1.2, 3.6]", res);
	}

	@Test
	void FloatArrayMul() {
		final String res = calculatorService.getMul("3.2;5.6", 2, "floatArray").toString();
		Assertions.assertEquals("[6.4, 11.2]", res);
	}

	@Test
	void FloatArrayDiv() {
		final String res = calculatorService.getDiv("3.2;5.6", 2, "floatArray").toString();
		Assertions.assertEquals("[1.6, 2.8]", res);
	}

	@Test
	void testErrorErrorWired() {
		Assertions.assertThrows(NoSuchBeanDefinitionException.class, () -> calculatorService.getSum(1, 2, "date"));
	}
}
